Next Greater Element | Animation | Coding Interview

  Рет қаралды 17,386

Dinesh Varyani

Dinesh Varyani

Күн бұрын

Пікірлер: 57
@shubhamagarwal1434
@shubhamagarwal1434 2 жыл бұрын
Best series for DS & Algo. I am also 10 yrs java exp guy. Was looking for DS & Algo free course over KZbin with java implementation and found this. Hats Off To You Man...Excellent Work. GOD BLESS YOU :)
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
Thanks !!!
@ascar66
@ascar66 2 жыл бұрын
Hi 10 yrs java exp guy. I didn't see your comment on previous video I thought you gave up on this playlist. Glad to see you here again )))
@shubhamagarwal1434
@shubhamagarwal1434 Жыл бұрын
@@ascar66 :)
@bpriorb
@bpriorb 2 жыл бұрын
Excellent work Dinesh describing the solution using a stack. I'm still struggling to fully understand the use of the stack without memorizing the solution. I think this technique can be used in other solutions as well. A "brute-force" two 'for' loop solution is easy, but this is much harder. Need to keep working on this...
@ajinxRGB
@ajinxRGB 2 жыл бұрын
//yeah i tried the two for loop approach, that works as well int m = 0; int arr[] = { 4, 7, 3, 4, 8, 1 }; int result[] = new int[arr.length]; for (int i = 0; i < arr.length; i++) { for (int j = i + 1; j < arr.length; j++) { if (arr[i] < arr[j]) { result[m] = arr[j]; break; } else { result[m] = -1; } } m++; } // for the last element result[arr.length-1]=-1;
@MohdDanish-kv8ry
@MohdDanish-kv8ry 3 жыл бұрын
level is increasing. Very helpful. Thanks
@itsdineshvaryani
@itsdineshvaryani 3 жыл бұрын
welcome !!!
@apsey2162
@apsey2162 2 жыл бұрын
Thanks a lot sir!!! . Keep uploading more videos like this.............
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
Sure !!!
@albinkafexhiu9259
@albinkafexhiu9259 Жыл бұрын
I think you should do Implementation to this video it is much better when we have both animation and implementation , BTW THANKS FOR ALL THE VIDEOS THIS IS BEST EXPLENATION I COULD FIND FOR ADS
@itsdineshvaryani
@itsdineshvaryani Жыл бұрын
Welcome
@AmanPandey-or3dc
@AmanPandey-or3dc 2 жыл бұрын
Sir I practice a lot on GFG, Hacker rank but still struggle to solve medium level problems and build logic. Please help. How should I prepare for fresher role interviews? Please Help?
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
Even I struggle to solve ... the idea still remains in practice ... practice and practice ... Be focused ... Be better than yesterday and soon after few months you will see change ... Dnt loose hope ... Keep solving problems ...
@AmanPandey-or3dc
@AmanPandey-or3dc 2 жыл бұрын
@@itsdineshvaryani thanks sir surely i will
@032_gowthamkumarm_ecea9
@032_gowthamkumarm_ecea9 Жыл бұрын
Hi, For [2,4,75,8,76,90,77,54] input should be passed in this code output should be wrong.
@AshishSingh-rx4sq
@AshishSingh-rx4sq 2 жыл бұрын
Great visualization and explanation.
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
Thanks !!!
@karentechnologies3990
@karentechnologies3990 2 жыл бұрын
Using stack to solve this problem is hard, why don't we make things easy and use nested for loop?
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
TC will increase ...
@mrunaligaikwad1953
@mrunaligaikwad1953 2 жыл бұрын
Why did we not sort the array in ascending order ? or do we need to maintain the order of the nos?
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
If we sort the array, the order of elements will be change and we will not be able to find any elements next greater to right !!!
@VivekSingh-ms3vu
@VivekSingh-ms3vu 3 жыл бұрын
Please upload operating system videos in java
@itsdineshvaryani
@itsdineshvaryani 3 жыл бұрын
operating system videos in Java ????
@VivekSingh-ms3vu
@VivekSingh-ms3vu 3 жыл бұрын
@@itsdineshvaryani various algorithm as well as codes like Peterson’s, dekker,etc
@itsdineshvaryani
@itsdineshvaryani 3 жыл бұрын
ok
@AdilSyed_Imam
@AdilSyed_Imam 3 жыл бұрын
What is time complexity for the solution?
@abdyashar5564
@abdyashar5564 2 жыл бұрын
Hello Sir. I'm following your DSA playlist consistently. Here when you described about the problem I'm just paused the video and I thought about the solution with pen and paper. after getting an idea I just implemented it to code. I solved this problem in such way and it still taking only one while loop while with two pointers, which is O(n) Time complexity. The output what i'm getting is correct. result is = [7, 8, 4, 8, -1, -1]; The two pointers concept I've learned from your DSA course on youtube. This algorithm also giving correct result with O(n) TC what is your opinion about this algo, kindly correct me if I'm wrong. public int[] nextGreaterElement(int[] arr) { int[] result = new int[arr.length]; //two pointer int i = 0; int j = i + 1; int k = arr.length - 1; int notExists = -1; while (i < arr.length) { // edge cases if (j >= arr.length) { result[i] = notExists; break; } if (arr[i] > arr[j] && j == k) { result[i] = notExists; i++; j = i + 1; continue; } //assigning the next greater element to the result array if (arr[i] < arr[j]) { result[i] = arr[j]; i++; j = i + 1; } else { j++; } } return result; }
@pradeeppradhi8792
@pradeeppradhi8792 2 жыл бұрын
I was actually thinking about the same code but in edge cases i was doing mistake so thanks for the code
@sumitpal6797
@sumitpal6797 Жыл бұрын
bro its not O(n)..... calculate the complexity of this :- [8,7,6,5,4,3,2,1,9]
@AhsanAli-vz6mg
@AhsanAli-vz6mg 3 жыл бұрын
Very well explained
@itsdineshvaryani
@itsdineshvaryani 3 жыл бұрын
thanks !!!
@ajose1070
@ajose1070 7 ай бұрын
this metthod doesnt pass all test cases and had to use int i = 2* arr.length-1 and arr[i%n]
@bibekanandabesra6415
@bibekanandabesra6415 2 жыл бұрын
will the timing complexity be O(n*n)?? [cannot type superscript here]
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
Nope !!!
@bibekanandabesra6415
@bibekanandabesra6415 2 жыл бұрын
@@itsdineshvaryani how much then😬??
@bpriorb
@bpriorb 2 жыл бұрын
I solved it using a "brute force" method first, using two 'for' loops, which is clearly O(n*n). Dinesh's way using a stack with a single 'for' loop is O(n) by my evaluation. It's a tradeoff of time vs space complexity. Please let me know if wrong. I've went thru Dinesh's solution a few times using the stack. It's quite tricky for me, and I'm still struggling how to think about it, without memorizing the solution.
@pentainamerica
@pentainamerica 2 жыл бұрын
we can solve this by using 2 for loops and just arrays right.....without using stacks..
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
nested for loops will increase the TC
@raghavmanchanda4736
@raghavmanchanda4736 3 жыл бұрын
Sir by much time will this course be completed
@itsdineshvaryani
@itsdineshvaryani 3 жыл бұрын
I will keep adding to this course ... DSA is very vast and never ending topic ...
@raghavmanchanda4736
@raghavmanchanda4736 3 жыл бұрын
@@itsdineshvaryani ok sir for sure
@shahidulhasan1147
@shahidulhasan1147 3 жыл бұрын
Sir i have the same question. Till where should we think that now It's time for us to stop dsa and learn development?
@itsdineshvaryani
@itsdineshvaryani 3 жыл бұрын
look knowledge is never measured by time ... you cannot stop dsa at any point and learn development or vice versa ... i hv more than 11 years of exp but i still struggle to solve leetcode questions ... but am happy with what i knw .... its a journey dnt count it on time .... you will realize this when u will hv exp ... my words will sound correct .... practice both and dnt stop anything to learn other ... do both simultaneously ...
@shahidulhasan1147
@shahidulhasan1147 3 жыл бұрын
Thanks sir.i got it.you're great
@itsdineshvaryani
@itsdineshvaryani 3 жыл бұрын
thanks !!! keep supporting !!!
@rahuldubey9999
@rahuldubey9999 2 жыл бұрын
hi i tried with this input value int arr[] = {2, 8, 9, 6, 7}; and getting the wrong output as {8 9 -1 7 -1} . I think it should be { 6, 9, -1, 7, -1} can you please check and help me. what I am doing wrong. i pasted the whole code below. int arr[] = {2, 8, 9, 6, 7}; int result[] = new int[arr.length]; Stack stack = new Stack(); for ( int i = arr.length-1; i >=0; i-- ) { if(!stack.isEmpty()) { while(!stack.isEmpty() && stack.peek() System.out.print(a+" "));
@yuva0101
@yuva0101 2 жыл бұрын
Output is correct boss!! I think you understood the problem wrong. For 2-8, for 8-9, for 9- -1, for 6-7, and for 7 - -1.
@rahuldubey9999
@rahuldubey9999 2 жыл бұрын
@@yuva0101 Thanks Yuvasai... I am new to the coding...learning steps by steps
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
Output is correct !!! Its next greater element towards right !!!
@Jayantch.999
@Jayantch.999 2 жыл бұрын
super explanation
@itsdineshvaryani
@itsdineshvaryani 2 жыл бұрын
thanks
@poorpanda9033
@poorpanda9033 Жыл бұрын
Thank You so much sir !
@sadiulhakim7814
@sadiulhakim7814 2 жыл бұрын
Hello, sir. I tried this algorithm at myself...... My Solution.. public int[] nextGreater(int[] arr){ int[] result=new int[arr.length]; for(int i=0;i
@ERDheerajmann
@ERDheerajmann 11 ай бұрын
🙏
Product of an Array except self | Animation | Coding Interview
22:25
Dinesh Varyani
Рет қаралды 4,6 М.
СКОЛЬКО ПАЛЬЦЕВ ТУТ?
00:16
Masomka
Рет қаралды 3,3 МЛН
Hoodie gets wicked makeover! 😲
00:47
Justin Flom
Рет қаралды 133 МЛН
Generate Binary numbers from 1 to n using a Queue | Animation
18:38
Dinesh Varyani
Рет қаралды 16 М.
Being Competent With Coding Is More Fun
11:13
TheVimeagen
Рет қаралды 116 М.
Iterative Preorder traversal of a Binary Tree in Java
16:34
Dinesh Varyani
Рет қаралды 31 М.
Next Greater Element I - Leetcode 496 - Python
14:53
NeetCode
Рет қаралды 79 М.
How to represent a Binary Heap in Java? | Animation
11:42
Dinesh Varyani
Рет қаралды 10 М.
Master Pointers in C:  10X Your C Coding!
14:12
Dave's Garage
Рет қаралды 327 М.
ASMR Programming - Spinning Cube - No Talking
20:45
Servet Gulnaroglu
Рет қаралды 4,2 МЛН
you will never ask about pointers again after watching this video
8:03